<%@ Page %>
<script language="C#" runat="server">
    string username = null;
    bool QSusername = false;
    void Page_Load(Object Src, EventArgs E) {
        username = GetUserName();
    }
    
    public string GetUserName() {
        // load from the QS
        string qs = Request.QueryString["user"];  
        if (qs != null && qs.Length > 0) {
            QSusername = true;
            return qs;
        }

        // load from the windows creds
        string delimStr = "\\";
        char [] delimiter = delimStr.ToCharArray();

        string[] parseName = User.Identity.Name.Split(delimiter);
        if (parseName.Length > 1) {
            return parseName[1];
        }
        
        // no ID found
        return "anonymous";
    }
</script>

<html>
<head>
<title>dchat2</title>
<script type="text/javascript">

// 2002 Glen Murphy : http://glenmurphy.com/ : glen@glenmurphy.com
// This is distributed under the GPL : http://www.gnu.org/copyleft/gpl.html
// Remote-Scripting Code in this page based on code by Dan Pupius, http://www.pupius.co.uk/
// Ported to C# and modified by Julien Couvreur (Dumky) : http://blog.monstuff.com

function g(o) {
	return document.getElementById(o)
	}
	
// remotescript specific stuff

var ci = 0;
var co = new Array();
var d = document
var h = d.getElementsByTagName('head').item(0);


function cmdobjs(cmd, postFunc) {
	this.loading = true;
	this.cmd = cmd;
	this.postFunc = postFunc;
	}

// make a call to the server c("foo(bar)", "callback()");
function c(cmd, postFunc) {
	ci++;
	co[ci] = new cmdobjs(cmd, postFunc);
	runFunc(ci, cmd);
	}

function endFunc(id) {
	var old = document.getElementById('RS'+id);
	if (old) h.removeChild(old);
	co[id].loading = false;
	eval(co[id].postFunc);
	}

function runFunc(id, cmd) {
	s = d.createElement('script');
	s.src = "f.ashx?<% if(QSusername) { Response.Write("user=" + username + "&"); }%>id="+id+"&cmd=" + encodeURIComponent(cmd);
	s.type = 'text/javascript';
	s.defer = true;
	s.id = 'RS'+id;
	void(h.appendChild(s));
	}

// chat specific stuff.

var spintime = 3000;
var username = '<% Response.Write(username); %>';
var laststream = '';
var spinning = false;

function initspin() {
	if(!spinning) {
		spin();
		spinning = true;
		}
	}

function spin() {
	c("stream('"+laststream+"')","");
	c("users()","");
	setTimeout('spin()',spintime);
	}



// streaming

function safe_filter(c) {
	c = c.replace(/\</g,"&lt;");
	c = c.replace(/\>/g,"&gt;");
	c = c.replace(/\"/g,"&quot;");
	c = c.replace(/\'/g,"&#39;");
	c = c.replace(/\\/g,"&#92;");
	return c;
	}

function strip_filter(c) {
	c = c.replace(/\</g,"&lt;");
	c = c.replace(/\>/g,"&gt;");
	c = c.replace(/\"/g,"");
	c = c.replace(/\'/g,"");
	c = c.replace(/\\/g,"");
	return c;
	}

function addtxt(t) {
	g('main').innerHTML += t;
	}

function newmsg(name, msg) {
	msg = safe_filter(msg);
	t = '<table width="99%" border="0" cellspacing="0" cellpadding="0"><tr>';
	t += '<tr><td class="name" valign="top">'+name+'&nbsp;:&nbsp;</td>';
	t += '<td width="99%" class="msg">'+msg+'</td></tr></table>';
	addtxt(t);
	}

function chanmsg(msg) {
	addtxt('<span class="chanmsg">'+msg+'</span><br>');
	}

function sysmsg(msg) {
	addtxt('<span class="sysmsg">'+msg+'</span><br>');
	}

function actnmsg(msg) {
	addtxt('<span class="actnmsg">* '+msg+'</span><br>');
	}

var users = new Array();

function clearusers() {
	users = new Array();
	}

function cleartxt() {
	g('main').innerHTML = "";
	}

function listuser(name) {
	users[users.length] = name;
	}

function upduserslist() {
	var output = '<b>users online</b><br />';
	for(i=0;i<users.length;i++) {
		if(users[i] == username) {
			users[i] = "<u>"+users[i]+"</u>";
			}
		output += '<br />'+users[i];
		}
	g('users').innerHTML = output;
	}

// login


function gologin() {
	cmdlogin = strip_filter(g('cmdlogin').value);
	c("login('"+cmdlogin+"')","procLogin()");
	return false;
	}

// commands
function gocmd() {
	cmd = g('cmd').value;
	g('cmd').value = '';
	cmd = safe_filter(cmd);
	if(cmd.substring(0,1) != ".") {
        newmsg(username, cmd);
    }

	c("cmd('"+cmd+"')","");
	g('cmd').focus();
	return false;
	}
	
</script>



<style type="text/css">
body, td {margin:0px; background-color:#EBEBEB; color:#5E5E5E; font-family:verdana, arial; font-size:11px;}
#cmd {background-color:#F6F6F6; border-top:1px solid #C6C6C6; border-bottom:0px; border-left:0px; border-right:0px; position:absolute; bottom:0px; left:0px; width:100%;}
#users {background-color:#F6F6F6; z-index:15; position:absolute; top:0px; right:0px; border-left:1px solid #C6C6C6; border-bottom:1px solid #C6C6C6; width:100px; padding:2px; color:#5E5E5E; font-family:verdana, arial; font-size:10px;}
#main {position:absolute; bottom:20px; left:3px;}

#errorlog {position:absolute; top:0px; left:0px; z-index:10;}

input {font-family:verdana, arial; font-size:11px; color:#5E5E5E; background-color:#F6F6F6;}

.chanmsg {color:#19B700; font-weight:bold;}
.sysmsg {color:#D50000; font-weight:bold;}
.actnmsg {color:#FF0000; font-weight:bold;}
.name {font-weight:bold;}
.msg {font-weight:normal;}
</style>

</head>
<body onload="initspin();g('cmd').focus();">

<div id="users"></div>
<div id="main"></div>

<form style="padding:0px; margin:0px;" onsubmit="return gocmd();">
<input id="cmd" name="cmd">
</form>

</body>
</html>